Index: palm/trunk/SOURCE/advec_w_ups.f90
===================================================================
--- palm/trunk/SOURCE/advec_w_ups.f90	(revision 1)
+++ palm/trunk/SOURCE/advec_w_ups.f90	(revision 1)
@@ -0,0 +1,189 @@
+ SUBROUTINE advec_w_ups
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
+! -----------------
+! 
+!
+! Former revisions:
+! -----------------
+! $Log: advec_w_ups.f90,v $
+! Revision 1.6  2004/04/30 08:05:05  raasch
+! Enlarged transposition arrays introduced
+!
+! Revision 1.5  2003/03/16 09:26:46  raasch
+! Two underscores (_) are placed in front of all define-strings
+!
+! Revision 1.4  2001/03/29 17:37:53  raasch
+! v_ad is now allocated locally, several temporary arrays removed from
+! argument lists of spline_* and long_filter_*
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.3  2001/01/22 05:23:31  raasch
+! Module test_variables removed
+!
+! Revision 1.2  2000/01/20 09:57:15  letzel
+! All comments translated into English
+!
+! Revision 1.1  1999/02/05 08:52:09  raasch
+! Initial revision
+!
+!
+! Description:
+! ------------
+! Upstream-Spline advection of the w velocity-component. The advection process
+! is divided into three subsequent steps, one for each of the dimensions. The
+! result is stored as a tendency in array tend. The computation of the cubic
+! splines and the possible execution of the Long-filter require that all grid
+! points of the relevant dimension are available. For model runs on more than
+! one PE therefore both the advected and the advecting quantities are
+! transposed accordingly.
+!
+! Internally used arrays:
+! v_ad = scalar quantity to be advected, initialised = w at the beginning, also
+!        being used as temporary storage after each time step
+! d    = advecting component (u, v, or w)
+!------------------------------------------------------------------------------!
+
+    USE advection
+    USE arrays_3d
+    USE cpulog
+    USE grid_variables
+    USE indices
+    USE interfaces
+    USE control_parameters
+
+    IMPLICIT NONE
+
+    INTEGER ::  i,j,k
+    REAL, DIMENSION(:,:,:), ALLOCATABLE ::  v_ad
+
+
+    CALL cpu_log( log_point_s(19), 'advec_w_ups', 'start' )
+
+#if defined( __parallel )
+
+!
+!-- Advection of w in x-direction:
+!-- Store w in temporary array v_ad (component to be advected, boundaries
+!-- are not used because they disturb the transposition)
+    ALLOCATE( v_ad(nzb+1:nzta,nys:nyna,nxl:nxra) )
+    v_ad = 0.0
+    v_ad(nzb+1:nzt,nys:nyn,nxl:nxr) = w(nzb+1:nzt,nys:nyn,nxl:nxr)
+
+!
+!-- Enlarge the size of tend, used as a working array for the transpositions
+    IF ( nxra > nxr  .OR.  nyna > nyn  .OR.  nza > nz )  THEN
+       DEALLOCATE( tend )
+       ALLOCATE( tend(1:nza,nys:nyna,nxl:nxra) )
+    ENDIF
+
+!
+!-- Transpose the component to be advected: z --> x
+    CALL transpose_zx( v_ad, tend, v_ad, tend, v_ad )
+
+#else
+
+!
+!-- Advection of w in x-direction:
+!-- Store w in temporary array v_ad (component to be advected)
+    ALLOCATE( v_ad(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+    v_ad(:,:,:) = w(:,:,:)
+
+#endif
+
+!
+!-- Advecting component (u) must be averaged out on the w grid
+    d = 0.0
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          DO  k = nzb+1, nzt
+             d(k,j,i) = 0.25 * ( u(k,j,i) + u(k,j,i+1) +   &
+                                 u(k+1,j,i+1) + u(k+1,j,i) ) - u_gtrans
+          ENDDO
+       ENDDO
+    ENDDO
+    
+#if defined( __parallel )
+
+!
+!-- Transpose the component to be advected: z --> x
+    CALL transpose_zx( d, tend, d, tend, d )
+
+#endif
+
+!
+!-- Upstream-Spline advection of w in x-direction. Array tend comes out
+!-- as v_ad before the advection step including cyclic boundaries.
+!-- It is needed for the long filter.
+    CALL spline_x( v_ad, d, 'w' )
+
+!
+!-- Advection of w in y-direction:
+!-- advecting component (v) must be averaged out on the w grid
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          DO  k = nzb+1, nzt
+             d(k,j,i) = 0.25 * ( v(k,j,i) + v(k,j+1,i) +   &
+                                 v(k+1,j+1,i) + v(k+1,j,i) ) - v_gtrans
+          ENDDO
+       ENDDO
+    ENDDO
+
+#if defined( __parallel )
+
+!
+!-- Transpose the advecting component: z --> y
+    CALL transpose_zx( d, tend, d, tend, d )
+    CALL transpose_xy( d, tend, d, tend, d )
+
+!
+!-- Transpose the component to be advected: x --> y
+    CALL transpose_xy( v_ad, tend, v_ad, tend, v_ad )
+
+#endif
+
+!
+!-- Upstream-Spline advection of w in y-direction
+    CALL spline_y( v_ad, d, 'w' )
+
+!
+!-- Advection of w in z-direction:
+!-- advecting component (d) = component to be advected (v_ad)
+    d(nzb+1:nzt,nys:nyn,nxl:nxr) = w(nzb+1:nzt,nys:nyn,nxl:nxr)
+
+#if defined( __parallel )
+
+!
+!-- Transpose the component to be advected: y --> z (= y --> x + x --> z)
+    CALL transpose_yx( v_ad, tend, v_ad, tend, v_ad )
+    CALL transpose_xz( v_ad, tend, v_ad, tend, v_ad )
+
+!
+!-- Resize tend to its normal size
+    IF ( nxra > nxr  .OR.  nyna > nyn  .OR.  nza > nz )  THEN
+       DEALLOCATE( tend )
+       ALLOCATE( tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+    ENDIF
+
+#endif
+
+!
+!-- Upstream-Spline advection of w in z-direction
+    CALL spline_z( v_ad, d, dzw, spl_tri_zw, 'w' )
+
+!
+!-- Compute the tendency term
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          DO  k = nzb+1, nzt
+             tend(k,j,i) = ( v_ad(k,j,i) - w(k,j,i) ) / dt_3d
+          ENDDO
+       ENDDO
+    ENDDO
+
+    DEALLOCATE( v_ad )
+
+    CALL cpu_log( log_point_s(19), 'advec_w_ups', 'stop' )
+
+ END SUBROUTINE advec_w_ups
Index: palm/trunk/SOURCE/asselin_filter.f90
===================================================================
--- palm/trunk/SOURCE/asselin_filter.f90	(revision 1)
+++ palm/trunk/SOURCE/asselin_filter.f90	(revision 1)
@@ -0,0 +1,123 @@
+ SUBROUTINE asselin_filter
+
+!-------------------------------------------------------------------------------!
+! Actual revisions:
+! -----------------
+! 
+!
+! Former revisions:
+! ---------------------
+! $Log: asselin_filter.f90,v $
+! Revision 1.8  2004/01/30 10:14:02  raasch
+! Scalar lower k index nzb replaced by 2d-array nzb_2d
+!
+! Revision 1.7  2003/03/16 09:26:58  raasch
+! Two underscores (_) are placed in front of all define-strings
+!
+! Revision 1.6  2003/03/14 13:37:38  raasch
+! Do loop constructs only for IBM, otherwise array notation re-introduced
+!
+! Revision 1.5  2002/12/19 13:45:57  raasch
+! Array notation changed to do-loop constructs due to better performance,
+! OpenMP directives added
+!
+! Revision 1.4  2002/05/15 10:00:18  raasch
+! Nothing changed
+!
+! Revision 1.3  2002/05/02  19:39:07  19:39:07  raasch (Siegfried Raasch)
+! Use of module interfaces included
+! 
+! Revision 1.2  2002/05/02 14:06:02  raasch
+! *** empty log message ***
+!
+! Revision 1.1  2002/05/02  13:43:53  13:43:53  raasch (Siegfried Raasch)
+! Initial revision
+! 
+!
+! Description:
+! -------------
+! Time filter needed for the leap-frog method
+!-------------------------------------------------------------------------------!
+
+    USE arrays_3d
+    USE control_parameters
+    USE cpulog 
+    USE indices
+    USE interfaces
+
+    IMPLICIT NONE
+
+    INTEGER ::  i, j, k
+
+
+    CALL cpu_log( log_point(9), 'timefilter', 'start' )
+
+!
+!-- Return to the calling routine, if time filter is not to be applied
+    IF ( asselin_filter_factor == 0.0 )  RETURN
+
+!
+!-- Apply the time filter
+#if defined( __ibm )
+!$OMP PARALLEL PRIVATE (i,j,k)
+!$OMP DO
+    DO  i = nxl-1, nxr+1
+       DO  j = nys-1, nyn+1
+
+          DO  k = nzb_2d(j,i), nzt+1
+             u(k,j,i) = u(k,j,i) + asselin_filter_factor * &
+                                   ( u_p(k,j,i) - 2.0 * u(k,j,i) + u_m(k,j,i) )
+             v(k,j,i) = v(k,j,i) + asselin_filter_factor * &
+                                   ( v_p(k,j,i) - 2.0 * v(k,j,i) + v_m(k,j,i) )
+             w(k,j,i) = w(k,j,i) + asselin_filter_factor * &
+                                   ( w_p(k,j,i) - 2.0 * w(k,j,i) + w_m(k,j,i) )
+          ENDDO
+
+          IF ( scalar_advec /= 'bc-scheme' )  THEN
+             DO  k = nzb_2d(j,i), nzt+1
+                pt(k,j,i) = pt(k,j,i) + asselin_filter_factor * &
+                            ( pt_p(k,j,i) - 2.0 * pt(k,j,i) + pt_m(k,j,i) )
+             ENDDO
+          ENDIF
+
+          IF ( .NOT. constant_diffusion  .AND.  scalar_advec /= 'bc-scheme' ) &
+          THEN
+             DO  k = nzb_2d(j,i), nzt+1
+                e(k,j,i) = e(k,j,i) + asselin_filter_factor * &
+                           ( e_p(k,j,i) - 2.0 * e(k,j,i) + e_m(k,j,i) )
+             ENDDO
+          ENDIF
+
+          IF ( ( moisture .OR. passive_scalar )  .AND. &
+             scalar_advec /= 'bc-scheme' )  THEN
+             DO  k = nzb_2d(j,i), nzt+1
+                q(k,j,i) = q(k,j,i) + asselin_filter_factor * &
+                           ( q_p(k,j,i) - 2.0 * q(k,j,i) + q_m(k,j,i) )
+             ENDDO
+          ENDIF
+
+       ENDDO
+    ENDDO
+!$OMP END PARALLEL
+#else
+    u = u + asselin_filter_factor * ( u_p - 2.0 * u + u_m )
+    v = v + asselin_filter_factor * ( v_p - 2.0 * v + v_m )
+    w = w + asselin_filter_factor * ( w_p - 2.0 * w + w_m )
+
+    IF ( scalar_advec /= 'bc-scheme' )  THEN
+       pt = pt + asselin_filter_factor * ( pt_p - 2.0 * pt + pt_m )
+    ENDIF
+
+    IF ( .NOT. constant_diffusion  .AND.  scalar_advec /= 'bc-scheme' )  THEN
+       e = e + asselin_filter_factor * ( e_p - 2.0 * e + e_m )
+    ENDIF
+
+    IF ( ( moisture .OR. passive_scalar )  .AND. &
+         scalar_advec /= 'bc-scheme' )  THEN
+       q = q + asselin_filter_factor * ( q_p - 2.0 * q + q_m )
+    ENDIF
+#endif
+
+    CALL cpu_log( log_point(9), 'timefilter', 'stop' )
+
+ END SUBROUTINE asselin_filter
Index: palm/trunk/SOURCE/average_3d_data.f90
===================================================================
--- palm/trunk/SOURCE/average_3d_data.f90	(revision 4901)
+++ palm/trunk/SOURCE/average_3d_data.f90	(revision 1)
@@ -1,63 +1,12 @@
-!> @file average_3d_data.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
+ SUBROUTINE average_3d_data
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
 ! -----------------
 ! 
-! 
+!
 ! Former revisions:
 ! -----------------
-! $Id$
-! bugfix: average_count_3d is set to integer 0
-! 
-! 4514 2020-04-30 16:29:59Z suehring
-! Enable output of qsurf and ssurf
-! 
-! 4509 2020-04-26 15:57:55Z raasch
-! file re-formatted to follow the PALM coding standard
-! 
-! 4457 2020-03-11 14:20:43Z raasch
-! use statement for exchange horiz added,
-! bugfix for call of exchange horiz 2d
-!
-! 4360 2020-01-07 11:25:50Z suehring
-! Move 2-m potential temperature output to diagnostic_output_quantities
-! 
-! 4182 2019-08-22 15:20:23Z scharf
-! Corrected "Former revisions" section
-! 
-! 4048 2019-06-21 21:00:21Z knoop
-! Moved tcm_3d_data_averaging to module_interface
-! 
-! 4039 2019-06-18 10:32:41Z suehring
-! Modularize diagnostic output
-! 
-! 3994 2019-05-22 18:08:09Z suehring
-! output of turbulence intensity added
-! 
-! 3933 2019-04-25 12:33:20Z kanani
-! Bugfix in CASE theta_2m*, removal of redundant code
-! 
-! 3773 2019-03-01 08:56:57Z maronga
-! Added output of theta_2m*_xy_av
-! 
-! 3655 2019-01-07 16:51:22Z knoop
-! Implementation of the PALM module interface
-!
+! $Log: average_3d_data.f90,v $
 ! Revision 1.1  2006/02/23 09:48:58  raasch
 ! Initial revision
@@ -66,39 +15,18 @@
 ! Description:
 ! ------------
-!> Time-averaging of 3d-data-arrays.
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE average_3d_data
- 
-
+! Time-averaging of 3d-data-arrays.
+!------------------------------------------------------------------------------!
+
+    USE arrays_3d
     USE averaging
-
-    USE control_parameters,                                                                        &
-        ONLY:  average_count_3d, doav, doav_n, varnamelength
-
-    USE cpulog,                                                                                    &
-        ONLY:  cpu_log, log_point
-
-    USE exchange_horiz_mod,                                                                        &
-        ONLY:  exchange_horiz_2d
-
-    USE indices,                                                                                   &
-        ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt
-
-    USE kinds
-
-    USE module_interface,                                                                          &
-        ONLY:  module_interface_3d_data_averaging
-
-
-
+    USE cloud_parameters
+    USE control_parameters
+    USE cpulog
+    USE indices
+    USE interfaces
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i   !< loop index
-    INTEGER(iwp) ::  ii  !< loop index
-    INTEGER(iwp) ::  j   !< loop index
-    INTEGER(iwp) ::  k   !< loop index
-
-    CHARACTER (LEN=varnamelength) ::  trimvar  !< TRIM of output-variable string
+    INTEGER ::  i, ii, j, k
 
 
@@ -113,350 +41,178 @@
     DO  ii = 1, doav_n
 
-       trimvar = TRIM( doav(ii) )
-
 !
 !--    Store the array chosen on the temporary array.
-       SELECT CASE ( trimvar )
+       SELECT CASE ( TRIM( doav(ii) ) )
 
           CASE ( 'e' )
-             IF ( ALLOCATED( e_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         e_av(k,j,i) = e_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'ghf*' )
-             IF ( ALLOCATED( ghf_av ) )  THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      ghf_av(j,i) = ghf_av(j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-                CALL exchange_horiz_2d( ghf_av )
-             ENDIF
-
-          CASE ( 'qsws*' )
-             IF ( ALLOCATED( qsws_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      qsws_av(j,i) = qsws_av(j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-                CALL exchange_horiz_2d( qsws_av )
-             ENDIF
-
-          CASE ( 'thetal' )
-             IF ( ALLOCATED( lpt_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         lpt_av(k,j,i) = lpt_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      e_av(k,j,i) = e_av(k,j,i) / REAL( average_count_3d )
+                   ENDDO
+                ENDDO
+             ENDDO
 
           CASE ( 'lwp*' )
-             IF ( ALLOCATED( lwp_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      lwp_av(j,i) = lwp_av(j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDIF
-
-         CASE ( 'ol*' )
-             IF ( ALLOCATED( ol_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      ol_av(j,i) = ol_av(j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-                CALL exchange_horiz_2d( ol_av )
-             ENDIF
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   lwp_av(j,i) = lwp_av(j,i) / REAL( average_count_3d )
+                ENDDO
+             ENDDO
 
           CASE ( 'p' )
-             IF ( ALLOCATED( p_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         p_av(k,j,i) = p_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      p_av(k,j,i) = p_av(k,j,i) / REAL( average_count_3d )
+                   ENDDO
+                ENDDO
+             ENDDO
 
           CASE ( 'pc' )
-             IF ( ALLOCATED( pc_av ) )  THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      DO  k = nzb, nzt+1
-                         pc_av(k,j,i) = pc_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb, nzt+1
+                      pc_av(k,j,i) = pc_av(k,j,i) / REAL( average_count_3d )
+                   ENDDO
+                ENDDO
+             ENDDO
 
           CASE ( 'pr' )
-             IF ( ALLOCATED( pr_av ) )  THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      DO  k = nzb, nzt+1
-                         pr_av(k,j,i) = pr_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'theta' )
-             IF ( ALLOCATED( pt_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         pt_av(k,j,i) = pt_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb, nzt+1
+                      pr_av(k,j,i) = pr_av(k,j,i) / REAL( average_count_3d )
+                   ENDDO
+                ENDDO
+             ENDDO
+
+          CASE ( 'pt' )
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      pt_av(k,j,i) = pt_av(k,j,i) / REAL( average_count_3d )
+                   ENDDO
+                ENDDO
+             ENDDO
 
           CASE ( 'q' )
-             IF ( ALLOCATED( q_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         q_av(k,j,i) = q_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      q_av(k,j,i) = q_av(k,j,i) / REAL( average_count_3d )
+                   ENDDO
+                ENDDO
+             ENDDO
+             
           CASE ( 'ql' )
-             IF ( ALLOCATED( ql_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         ql_av(k,j,i) = ql_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      ql_av(k,j,i) = ql_av(k,j,i) / REAL( average_count_3d )
+                   ENDDO
+                ENDDO
+             ENDDO
 
           CASE ( 'ql_c' )
-             IF ( ALLOCATED( ql_c_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         ql_c_av(k,j,i) = ql_c_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      ql_c_av(k,j,i) = ql_c_av(k,j,i) / REAL( average_count_3d )
+                   ENDDO
+                ENDDO
+             ENDDO
 
           CASE ( 'ql_v' )
-             IF ( ALLOCATED( ql_v_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         ql_v_av(k,j,i) = ql_v_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      ql_v_av(k,j,i) = ql_v_av(k,j,i) / REAL( average_count_3d )
+                   ENDDO
+                ENDDO
+             ENDDO
 
           CASE ( 'ql_vp' )
-             IF ( ALLOCATED( ql_vp_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         ql_vp_av(k,j,i) = ql_vp_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      ql_vp_av(k,j,i) = ql_vp_av(k,j,i) / &
+                                        REAL( average_count_3d )
+                   ENDDO
+                ENDDO
+             ENDDO
 
           CASE ( 'qv' )
-             IF ( ALLOCATED( qv_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         qv_av(k,j,i) = qv_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
-         CASE ( 'qsurf*' )
-             IF ( ALLOCATED( qsurf_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      qsurf_av(j,i) = qsurf_av(j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-                CALL exchange_horiz_2d( qsurf_av )
-             ENDIF
-
-         CASE ( 'r_a*' )
-             IF ( ALLOCATED( r_a_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      r_a_av(j,i) = r_a_av(j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-                CALL exchange_horiz_2d( r_a_av )
-             ENDIF
-
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      qv_av(k,j,i) = qv_av(k,j,i) / REAL( average_count_3d )
+                   ENDDO
+                ENDDO
+             ENDDO
+             
           CASE ( 's' )
-             IF ( ALLOCATED( s_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         s_av(k,j,i) = s_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
-         CASE ( 'shf*' )
-             IF ( ALLOCATED( shf_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      shf_av(j,i) = shf_av(j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-                CALL exchange_horiz_2d( shf_av )
-             ENDIF
-
-          CASE ( 'ssurf*' )
-             IF ( ALLOCATED( ssurf_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      ssurf_av(j,i) = ssurf_av(j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-                CALL exchange_horiz_2d( ssurf_av )
-             ENDIF
-
-          CASE ( 'ssws*' )
-             IF ( ALLOCATED( ssws_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      ssws_av(j,i) = ssws_av(j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-                CALL exchange_horiz_2d( ssws_av )
-             ENDIF
-
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      s_av(k,j,i) = s_av(k,j,i) / REAL( average_count_3d )
+                   ENDDO
+                ENDDO
+             ENDDO
+             
           CASE ( 't*' )
-             IF ( ALLOCATED( ts_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      ts_av(j,i) = ts_av(j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-                CALL exchange_horiz_2d( ts_av )
-             ENDIF
-
-         CASE ( 'tsurf*' )
-             IF ( ALLOCATED( tsurf_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      tsurf_av(j,i) = tsurf_av(j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-                CALL exchange_horiz_2d( tsurf_av )
-             ENDIF
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   ts_av(j,i) = ts_av(j,i) / REAL( average_count_3d )
+                ENDDO
+             ENDDO
 
           CASE ( 'u' )
-             IF ( ALLOCATED( u_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         u_av(k,j,i) = u_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'us*' )
-             IF ( ALLOCATED( us_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      us_av(j,i) = us_av(j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-                CALL exchange_horiz_2d( us_av )
-             ENDIF
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      u_av(k,j,i) = u_av(k,j,i) / REAL( average_count_3d )
+                   ENDDO
+                ENDDO
+             ENDDO
+
+          CASE ( 'u*' )
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   us_av(j,i) = us_av(j,i) / REAL( average_count_3d )
+                ENDDO
+             ENDDO
 
           CASE ( 'v' )
-             IF ( ALLOCATED( v_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         v_av(k,j,i) = v_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'thetav' )
-             IF ( ALLOCATED( vpt_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         vpt_av(k,j,i) = vpt_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      v_av(k,j,i) = v_av(k,j,i) / REAL( average_count_3d )
+                   ENDDO
+                ENDDO
+             ENDDO
+
+          CASE ( 'vpt' )
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      vpt_av(k,j,i) = vpt_av(k,j,i) / REAL( average_count_3d )
+                   ENDDO
+                ENDDO
+             ENDDO
 
           CASE ( 'w' )
-             IF ( ALLOCATED( w_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         w_av(k,j,i) = w_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'z0*' )
-             IF ( ALLOCATED( z0_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      z0_av(j,i) = z0_av(j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-                CALL exchange_horiz_2d( z0_av )
-             ENDIF
-
-          CASE ( 'z0h*' )
-             IF ( ALLOCATED( z0h_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      z0h_av(j,i) = z0h_av(j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-                CALL exchange_horiz_2d( z0h_av )
-             ENDIF
-
-          CASE ( 'z0q*' )
-             IF ( ALLOCATED( z0q_av ) )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      z0q_av(j,i) = z0q_av(j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-                CALL exchange_horiz_2d( z0q_av )
-             ENDIF
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      w_av(k,j,i) = w_av(k,j,i) / REAL( average_count_3d )
+                   ENDDO
+                ENDDO
+             ENDDO
 
           CASE DEFAULT
 !
-!--          Averaging of data from all other modules
-             CALL module_interface_3d_data_averaging( 'average', trimvar )
+!--          User-defined quantity
+             CALL user_3d_data_averaging( 'average', doav(ii) )
 
        END SELECT
@@ -466,7 +222,7 @@
 !
 !-- Reset the counter
-    average_count_3d = 0_iwp
-
-    CALL cpu_log( log_point(35), 'average_3d_data', 'stop' )
+    average_count_3d = 0.0
+
+    CALL cpu_log (log_point(35),'average_3d_data','stop','nobarrier')
 
 
